#include "C:\MOI PROEKT\term_titan\digital_titan_termo\main.h"


// 
void output_lcd(void);
void output_lcd_blink(void);
void set_trism_A(char);
void set_trism_B(char);

#include "DS18B20.c"

#int_TIMER0
void  TIMER0_isr(void) // 8 ms
{
   // 
   //============================================================
   if(!input(plus))
   {  
      if(plus_butt.down)
         plus_butt.down--;
      else
      {
         plus_butt.press=1;
         plus_butt.no_press=0;
      }
   }
   else
   {
      if(plus_butt.down<12)
         plus_butt.down++; // 96 ms
      else
      {
         plus_butt.no_press=1;
         plus_butt.press=0;
      }
   }
      
   //   
   //----------------------------------------------------------
   if(!input(minus))
   {  
      if(minus_butt.down)
         minus_butt.down--;
      else
      {
         minus_butt.press=1;
         minus_butt.no_press=0;
      }
   }
   else
   {
      if(minus_butt.down<12)
         minus_butt.down++; // 96 ms
      else   
      {
         minus_butt.no_press=1;
         minus_butt.press=0;
      }
   }
   
   //======================================================================
   //      200  
   if(temp==31)
   {
     read_temp();
     temp=0;
   }
   else temp++;
   
  
  //       
  //========================================================================
   indic=1; //    
  
   if(temp_blink>63) //         
   {                 //  
      temp_blink=0;
      indic_blink=1;
      set_time_blink_ystav=1;
   }
   else
      temp_blink++;
}


//------------------------------------------------------------------------
void main()
{

   
   ptr_plus_butt=&plus_butt;//    
   ptr_minus_butt=&minus_butt;//    
   ptr_ds18b20=&ds18b20; //   
   
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_32); // 8 ms
   enable_interrupts(INT_TIMER0);
   enable_interrupts(GLOBAL);

   output_A(0b11111100); //     
   output_B(0b11111110); // 
   set_trism_A(0b11111100); //   
   set_trism_B(0x00);
   
   plus_butt.no_press=1;
   plus_butt.press=0;
   plus_butt.memory=0;
   minus_butt.no_press=1;
   minus_butt.press=0;
   minus_butt.memory=0;
   
   //    ,  100 
   ystav=read_eeprom(0);
   if(ystav>99)
      ystav=0;
      
   //========================================
   init_temp();
   read_temp(); //      crc
   
   //=======================================================================
   while(TRUE) //  
   {
      if(ptr_ds18b20->crc)
      {
         //      
         //      10 
         if(ptr_ds18b20->data>ystav)
         {
            rele_temp=0x7f;
            output_low(rele);
         }
         if(ystav>10)
         {
            if(ptr_ds18b20->data<(ystav-10))
            {
               rele_temp=0xff;
               output_high(rele);
            }
         }
//------------------------------------------------------------------------------
         //      ,   
         //      (  memory_press
         //  plus  minus
         //-----------------------------------------------------------------------
         if(!plus_butt.memory)
         {
            if(plus_butt.press)
            {
               if(ystav<99&&ystav>=0)
                  ystav++;
               else ystav=0;   
               write_eeprom(0,ystav);
               // time_blink_ystav     
               //   
               time_blink_ystav=20;
               plus_butt.memory=1;
            }
         }
         if(plus_butt.no_press)
            plus_butt.memory=0;
            
         //------------------------------------------------------------------------
         //   
         if(!minus_butt.memory)
         {
            if(minus_butt.press)
            {
               if(ystav<99&&ystav>0)
                  ystav--;
               else ystav=0;  
               write_eeprom(0,ystav);
               // time_blink_ystav     
               //   
               time_blink_ystav=20;
               minus_butt.memory=1;
            }
         }
         if(minus_butt.no_press)
            minus_butt.memory=0;
 //---------------------------------------------------------------------------------           
         //       
         if(time_blink_ystav) //   10    
         {
            if(indic_blink)
               time_blink_ystav--;
            output_lcd_blink();
         }
         else //   
         {
            if(!ptr_ds18b20->znak) //   
               output_lcd();
         }
      }
      else
         output_low(rele); //      
   }
}

//============================================================================
void output_lcd(void)
{
   //      ,     
   //    
   char edin,dec;
   
   if(indic) //   
   {
      //       
      //    
      dec=ptr_ds18b20->data/10;
      edin=ptr_ds18b20->data-dec*10;
      
      // 
      output_B(0xff&rele_temp);
      set_trism_A(0b11111100); //    
      
      if(temp_lcd&0x01)
      {
         output_B(mas[dec]&rele_temp);
         output_A(0x02);  //  
         temp_lcd++; //    
         indic=0;    //    
      }
      else
      {
         output_B(mas[edin]&rele_temp);
         output_A(0x01);  //   
         temp_lcd++; //    
         indic=0;    //    
      }
   }
}

//============================================================================
void output_lcd_blink(void)
{
   //    ,     
   //  ,         
   
   char edin,dec;
   
   if(indic_blink)
   {
      temp_lcd_blink_0_5++;
      indic_blink=0; //   
   }
      if(indic)
      {
         if(temp_lcd_blink_0_5&0x01) //   
         {
            //       
            //    
            dec=ystav/10;
            edin=ystav-dec*10;
      
            // 
            output_B(0xff&rele_temp);
            set_trism_A(0b11111100); //    
      
            if(temp_lcd&0x01)
            {
               output_B(mas[dec]&rele_temp);
               output_A(0x02);  //  
               temp_lcd++; //    
               indic=0;    //    
            }
            else
            {
               output_B(mas[edin]&rele_temp);
               output_A(0x01);  //   
               temp_lcd++; //    
               indic=0;    //    
            }
         }   
         else  //    
         {
            set_trism_A(0b11111100); //    
            output_A(0x03);
            indic=0;    //    
         }
      }
  
}
       
void set_trism_A(char new)
{
   #asm
      BSF    03.5
      MOVF   new,0
      MOVWF  05
      BCF    03.5
   #endasm
}
     
void set_trism_B(char new)
{
   #asm
      BSF    03.5
      MOVF   new,0
      MOVWF  06
      BCF    03.5
   #endasm
}     
